#include <P18F452.h>
#include <P18F452_bits.h>
#include <PortBits.h>

#define APROCFREQ 40000000

#define BITSIZE 16
#define BOOTADDRESS 0
#define FIRSTRAM 0x00
#define LASTRAM 0x5FF
#define HASOSCCAL 0
#define nPAGESRAM 1
#define nPAGESROM 1
//
// Header file - should be included in all C files used within the program
// This file is created automatically and should not be changed
//

//
// Functions
//
void UserInitialise();			// Your initialisation code
void UserInterrupt();			// Your interrupt code
void UserLoop();			// your Main loop code


#define PortInnCopy 14
#define PortOutnCopy 19
// **********
//
// Port Driver
//
// **********
#define PortOutUsed 1
#define PortOut18Used 1
#define InitialValue18 0
#define Out18Port PORTD
#define Out18Bit 7
#define BEEPPort PORTD
#define BEEPBit 7
#define BEEP bRD7
#define BEEPTris bTRD7
// **********
//
// Port Input
//
// **********
#define PortInUsed 1
#define PortIn13Used 1
#define In13Port PORTB
#define In13Bit 7
#define Z_CLOCKPort PORTB
#define Z_CLOCKBit 7
#define Z_CLOCK bRB7
#define Z_CLOCKTris bTRB7
// **********
//
// Port Input
//
// **********
#define PortIn12Used 1
#define In12Port PORTB
#define In12Bit 6
#define Y_CLOCKPort PORTB
#define Y_CLOCKBit 6
#define Y_CLOCK bRB6
#define Y_CLOCKTris bTRB6
// **********
//
// Port Input
//
// **********
#define PortIn11Used 1
#define In11Port PORTB
#define In11Bit 5
#define X_CLOCKPort PORTB
#define X_CLOCKBit 5
#define X_CLOCK bRB5
#define X_CLOCKTris bTRB5
// **********
//
// Port Driver
//
// **********
#define PortOut17Used 1
#define InitialValue17 0
#define Out17Port PORTB
#define Out17Bit 4
#define RBBPort PORTB
#define RBBBit 4
#define RBB bRB4
#define RBBTris bTRB4
// **********
//
// Port Input
//
// **********
#define PortIn10Used 1
#define In10Port PORTB
#define In10Bit 3
#define Z_DATAPort PORTB
#define Z_DATABit 3
#define Z_DATA bRB3
#define Z_DATATris bTRB3
// **********
//
// Port Input
//
// **********
#define PortIn9Used 1
#define In9Port PORTB
#define In9Bit 2
#define Y_DATAPort PORTB
#define Y_DATABit 2
#define Y_DATA bRB2
#define Y_DATATris bTRB2
// **********
//
// Port Input
//
// **********
#define PortIn8Used 1
#define In8Port PORTB
#define In8Bit 1
#define X_DATAPort PORTB
#define X_DATABit 1
#define X_DATA bRB1
#define X_DATATris bTRB1
// **********
//
// Port Input
//
// **********
#define PortIn7Used 1
#define In7Port PORTB
#define In7Bit 0
#define KEY_Row5Port PORTB
#define KEY_Row5Bit 0
#define KEY_Row5 bRB0
#define KEY_Row5Tris bTRB0
// **********
//
// Port Driver
//
// **********
#define PortOut16Used 1
#define InitialValue16 0
#define Out16Port PORTD
#define Out16Bit 6
#define LCD_RSPort PORTD
#define LCD_RSBit 6
#define LCD_RS bRD6
#define LCD_RSTris bTRD6
// **********
//
// Port Driver
//
// **********
#define PortOut15Used 1
#define InitialValue15 0
#define Out15Port PORTD
#define Out15Bit 5
#define LCD_RWPort PORTD
#define LCD_RWBit 5
#define LCD_RW bRD5
#define LCD_RWTris bTRD5
// **********
//
// Port Driver
//
// **********
#define PortOut14Used 1
#define InitialValue14 0
#define Out14Port PORTD
#define Out14Bit 4
#define LCD_EPort PORTD
#define LCD_EBit 4
#define LCD_E bRD4
#define LCD_ETris bTRD4
// **********
//
// Port Input
//
// **********
#define PortIn6Used 1
#define In6Port PORTC
#define In6Bit 7
#define RXPort PORTC
#define RXBit 7
#define RX bRC7
#define RXTris bTRC7
// **********
//
// Port Driver
//
// **********
#define PortOut13Used 1
#define InitialValue13 0
#define Out13Port PORTC
#define Out13Bit 6
#define TXPort PORTC
#define TXBit 6
#define TX bRC6
#define TXTris bTRC6
// **********
//
// Port Driver
//
// **********
#define PortOut12Used 1
#define InitialValue12 0
#define Out12Port PORTC
#define Out12Bit 5
#define KEY_Col3Port PORTC
#define KEY_Col3Bit 5
#define KEY_Col3 bRC5
#define KEY_Col3Tris bTRC5
// **********
//
// Port Input
//
// **********
#define PortIn5Used 1
#define In5Port PORTC
#define In5Bit 4
#define SDAPort PORTC
#define SDABit 4
#define SDA bRC4
#define SDATris bTRC4
// **********
//
// Port Driver
//
// **********
#define PortOut11Used 1
#define InitialValue11 0
#define Out11Port PORTD
#define Out11Bit 3
#define LCD_DB7Port PORTD
#define LCD_DB7Bit 3
#define LCD_DB7 bRD3
#define LCD_DB7Tris bTRD3
// **********
//
// Port Driver
//
// **********
#define PortOut10Used 1
#define InitialValue10 0
#define Out10Port PORTD
#define Out10Bit 2
#define LCD_DB6Port PORTD
#define LCD_DB6Bit 2
#define LCD_DB6 bRD2
#define LCD_DB6Tris bTRD2
// **********
//
// Port Driver
//
// **********
#define PortOut9Used 1
#define InitialValue9 0
#define Out9Port PORTD
#define Out9Bit 1
#define LCD_DB4Port PORTD
#define LCD_DB4Bit 1
#define LCD_DB4 bRD1
#define LCD_DB4Tris bTRD1
// **********
//
// Port Driver
//
// **********
#define PortOut8Used 1
#define InitialValue8 0
#define Out8Port PORTD
#define Out8Bit 0
#define LCD_DB5Port PORTD
#define LCD_DB5Bit 0
#define LCD_DB5 bRD0
#define LCD_DB5Tris bTRD0
// **********
//
// Port Input
//
// **********
#define PortIn4Used 1
#define In4Port PORTC
#define In4Bit 3
#define SCLPort PORTC
#define SCLBit 3
#define SCL bRC3
#define SCLTris bTRC3
// **********
//
// Port Driver
//
// **********
#define PortOut7Used 1
#define InitialValue7 0
#define Out7Port PORTC
#define Out7Bit 2
#define KEY_Col4Port PORTC
#define KEY_Col4Bit 2
#define KEY_Col4 bRC2
#define KEY_Col4Tris bTRC2
// **********
//
// Port Driver
//
// **********
#define PortOut6Used 1
#define InitialValue6 0
#define Out6Port PORTC
#define Out6Bit 1
#define KEY_Col2Port PORTC
#define KEY_Col2Bit 1
#define KEY_Col2 bRC1
#define KEY_Col2Tris bTRC1
// **********
//
// Port Driver
//
// **********
#define PortOut5Used 1
#define InitialValue5 0
#define Out5Port PORTC
#define Out5Bit 0
#define KEY_Col1Port PORTC
#define KEY_Col1Bit 0
#define KEY_Col1 bRC0
#define KEY_Col1Tris bTRC0
// **********
//
// Port Input
//
// **********
#define PortIn3Used 1
#define In3Port PORTE
#define In3Bit 2
#define KEY_Row4Port PORTE
#define KEY_Row4Bit 2
#define KEY_Row4 bRE2
#define KEY_Row4Tris bTRE2
// **********
//
// Port Input
//
// **********
#define PortIn2Used 1
#define In2Port PORTE
#define In2Bit 1
#define KEY_Row3Port PORTE
#define KEY_Row3Bit 1
#define KEY_Row3 bRE1
#define KEY_Row3Tris bTRE1
// **********
//
// Port Input
//
// **********
#define PortIn1Used 1
#define In1Port PORTE
#define In1Bit 0
#define KEY_Row2Port PORTE
#define KEY_Row2Bit 0
#define KEY_Row2 bRE0
#define KEY_Row2Tris bTRE0
// **********
//
// Port Driver
//
// **********
#define PortOut4Used 1
#define InitialValue4 0
#define Out4Port PORTA
#define Out4Bit 5
#define SR_RCKPort PORTA
#define SR_RCKBit 5
#define SR_RCK bRA5
#define SR_RCKTris bTRA5
// **********
//
// Port Input
//
// **********
#define PortIn0Used 1
#define In0Port PORTA
#define In0Bit 4
#define KEY_Row1Port PORTA
#define KEY_Row1Bit 4
#define KEY_Row1 bRA4
#define KEY_Row1Tris bTRA4
// **********
//
// Port Driver
//
// **********
#define PortOut3Used 1
#define InitialValue3 0
#define Out3Port PORTA
#define Out3Bit 3
#define SR_SCKPort PORTA
#define SR_SCKBit 3
#define SR_SCK bRA3
#define SR_SCKTris bTRA3
// **********
//
// Port Driver
//
// **********
#define PortOut2Used 1
#define InitialValue2 0
#define Out2Port PORTA
#define Out2Bit 2
#define SR_GPort PORTA
#define SR_GBit 2
#define SR_G bRA2
#define SR_GTris bTRA2
// **********
//
// Port Driver
//
// **********
#define PortOut1Used 1
#define InitialValue1 0
#define Out1Port PORTA
#define Out1Bit 1
#define SR_SCLRPort PORTA
#define SR_SCLRBit 1
#define SR_SCLR bRA1
#define SR_SCLRTris bTRA1
// **********
//
// Port Driver
//
// **********
#define PortOut0Used 1
#define InitialValue0 0
#define Out0Port PORTA
#define Out0Bit 0
#define SR_SIPort PORTA
#define SR_SIBit 0
#define SR_SI bRA0
#define SR_SITris bTRA0

// **********
//
// Application Designer Variables
//
// **********


// Defines specified by 1 or more elements

